C
      SUBROUTINE LECTAM(MAT10,ITYP,TTO)
C
C     LIMP : DIMENSION MAXIMALE DU POTENTIEL
C     NFAM : NOMBRE DE FAMILLES D'ONDES
C     ISEP : SEPARATION DES GROUPES
      PARAMETER (LIMP=3200)
      PARAMETER (NFAM=5,ISEP=6)
C
C     DEVELOPPEMENT  DU POTENTIEL
C
C     MAT10-BORN  :  0-20,2-10,4-7,6-1,8-10
C     MAT10-ODD   :  COMPLETE DEVELOPMENT
C     MAT10= 0,3  :  CTE
C     MAT10= 4,5  :  BULL
C     MAT10= 6,7  :  XI
C     MAT10= 8,9  :  TAMURA(8ARGUMENTS)
C     ITYP 1=30D, 2=6M, 3=1Y, 4=PSI1, 5=8Y , 6=18Y
C             30   200   365    2000   3000   5000 
C
      DOUBLE PRECISION TTO,VITPR(ISEP),VITDB(ISEP),VITFN(ISEP),
     *VIT1(150),VIT2(150),VIT3(150),VITI,W(8),CN
      DIMENSION AMP(LIMP),TC(LIMP),BRN(4),IFAM(150)
      DIMENSION NGT(NFAM),NA(150),NB(150),NPRINC(150)
      DIMENSION IVO(LIMP),ISIG(LIMP),NN(LIMP,8),NPOT(ISEP)
      CHARACTER*8 OD(150),OX(ISEP),BL
      COMMON/POT/OD,AMP
      COMMON/POT1/NGT,NA,NB,NPRINC,NOT
      COMMON/COMP/NN,IVO,ISIG,NGR,NARG
      DATA BRN/9999.,1.5E-6,1.05E-6,.75E-6/,BL/' '/
      DATA W/14.492052109D0,0.549016530D0,0.041068639D0,0.004641837D+0
     10,0.002206413D+00,0.000001961D+00,.037604917D0,.025688387D0/
C
c      open(unit=10,file='anal.lst')
c      open(unit=13,file='/home/bernard/mttam/tam1200.dat')
c      open(unit=14,file='/home/bernard/mt/grouplim.dat')
      NARG=6
   11 BORN=0.
      IF(MAT10.GE.8)NARG=8
      IF(MAT10.EQ.0)BORN=20.
      IF(MAT10.EQ.2)BORN=10.
      IF(MAT10.EQ.4)BORN=1./.15
      IF(MAT10.EQ.6)BORN=1.
      IF(MAT10.EQ.8)BORN=10.
      DO 10 K=2,4
      BRN(K)=BORN*BRN(K)
   10 CONTINUE
      MAT11=MAT10-(MAT10/2)*2
      DO 225 J=1,NFAM
      NGT(J)=0
  225 CONTINUE    
      NA(1)=2
      DO 224 K=2,150
      NA(K)=0
      NB(K)=0
  224 NPRINC(K)=0
c     premiere lecture      
      I=1
      IF(MAT10.LT.6)THEN
      READ(13,101)(NN(I,J),J=1,6),(OD(K),K=1,5),IVO(I),NV3,      
     1AMP(I),TC(I)
      ELSE
      READ(13,100)(NN(I,J),J=1,6),(OD(K),K=1,5),IVO(I),NV3,
     1AMP(I),TC(I)
      END IF
      NV2=NV3
      GO TO 222
c     lectures suivantes      
  223 IF(MAT10.LT.6)THEN
      READ(13,101)(NN(I,J),J=1,6),(OD(K),K=1,5),IVO(I),NV3,
     1AMP(I),TC(I)
      ELSE
      READ(13,100)(NN(I,J),J=1,6),(OD(K),K=1,5),IVO(I),NV3,
     1AMP(I),TC(I)
      END IF
  100 FORMAT(6I2,4A6,A4,I1,4x,I4,2F8.6)
  101 FORMAT(6I2,4A6,A4,I1,3x,I3,2F9.5)  
      IF(NN(I,2).EQ.99)GO TO 228
c     amplitude et arguments      
  222 IF(IVO(I).LT.3)IVO(I)=2
      ISIG1=IVO(I)+NN(I,1)
      ISIG(I)=2*(ISIG1/2)-ISIG1
      IF(NARG.EQ.6)GO TO 2221
      IF(TC(I).NE.0)AMP(I)=AMP(I)+TC(I)*(TTO-2451545.0D0)/36525.D0
      NN(I,7)=0
      NN(I,8)=0
      IF(NN(I,4).EQ.9)THEN
      NN(I,7)=NN(I,5)
      NN(I,8)=NN(I,6)
      DO 2222 K=4,6
      NN(I,K)=0
 2222 CONTINUE
      END IF
c     developpement reduit      
 2221 IF(MAT11.EQ.1)GO TO 220
      KV=IVO(I)
      IF( ABS(AMP(I)).LT.BRN(KV))GO TO 233
  220 I=I+1
c     test de sequence  
  233 IF(NV2-NV3)232,234,232
  234 NV2=NV2+1
      GO TO 223
  232 WRITE(*,231)NV3,NV2
  231 FORMAT(19H ERREUR DE SEQUENCE,I5,' au lieu de ',I5)
      STOP
C
C     DETERMINATION DES GROUPES (indice KJ)
C
  228 NOT=I-1
C
C     LECTURE DES LIMITES DE GROUPE
C
      KJ=0
      KT=1
      LFAM=0
      NGO=1
    2 READ(14,102,END=3)KFAM,(VITDB(K),VITPR(K),VITFN(K),OX(K),NPOT(K)
     *,K=1,ISEP)  
  102 FORMAT(I2,2(3F12.8,A6,I2)/2X,2(3F12.8,A6,I2)/,2X,2(3F12.8,A6,I2))   
      if(kfam.eq.99)go to 3
      IF(OX(ITYP).EQ.BL)GOTO 2
      KJ=KJ+1
      VIT1(KJ)=VITDB(ITYP)
      VIT2(KJ)=VITPR(ITYP)
      VIT3(KJ)=VITFN(ITYP)+1.d-07
      IFAM(KJ)=KFAM
      OD(KJ)=OX(ITYP)
c     changement de famille
      if(kfam.gt.lfam)then
      ngt(kt)=kj-ngo
      ngo=kj
      lfam=kfam
      kt=kt+1
      end if
      GO TO 2
    3 continue
      write(10,1010)(ifam(k),od(k),vit1(k),vit2(k),vit3(k),k=1,kj)
 1010 format(2(i4,a6,3f10.5))
C
C     RECHERCHE DES GROUPES
C
      NGR=KJ
      NGT(KT)=NGR-NGO+1
      write(10,1011)(ngt(k),k=1,nfam)
 1011 format(' nombre de groupes par famille', 5I4)
      AMPO=0.
      IGR=1
      DO 30 I=2,NOT
      VITI=0.D0
      DO 246 K=1,NARG
      CN=NN(I,K)
      VITI=VITI+W(K)*CN
  246 CONTINUE
      IF(VITI.LE.VIT3(IGR))THEN
      if(abs(amp(i)).gt.ampo)then
      ampo=abs(amp(i))
      nprinc(igr)=i
      end if      
      ELSE
c     write(10,*)i,viti,vit3(igr)
      NB(IGR)=I-1
      KT=IFAM(IGR)
      IGR=IGR+1
      IF(IGR.GT.NGR)GO TO 91
      NA(IGR)=I
      AMPO=ABS(AMP(I))
      NPRINC(IGR)=I
      END IF
   30 CONTINUE
      NB(IGR)=NOT
      KT=IFAM(IGR)
    4 ifm=kt+1
      if(igr.lt.ngr)then
      write(10,1005)kt,igr
 1005 format('pas de famille superieure a ',i2,i4,' groupes')
      ngr=igr     
      end if
c     sortie         
c      write(10,*)not,ngr,ifm
      ngrt=0
      do 1002 jj=1,ifm
      ngrt=ngrt+ngt(jj)
 1002 continue
      do 1001 kj=1,ngrt
      write(10,1000)ifam(kj),od(kj),na(kj),nb(kj),nprinc(kj)
 1000 format(i4,a8,3i6)
 1001 continue
      RETURN
C     ERREURS
   91 WRITE(*,1006)NGR
 1006 FORMAT('PLUS DE ',I2,' FAMILLES')  
      NOT=I-1
      GO TO 4
      END

