      SUBROUTINE ELASTM(TJUL,R,HE,iter)
C     LIMP : DIMENSION MAXIMALE DU POTENTIEL
C     NFAM : NOMBRE DE FAMILLES D'ONDES
C     LONGITUDE East positive
      PARAMETER (LIMP=3200,NFAM=5,NPOT=3)
C
C     CALCUL DES ELEMENTS ASTRONOMIQUES
C
      IMPLICIT REAL * 8(A-H,O-Z)
      REAL*4 APA(100)
      DIMENSION R(1),PG(NPOT,NFAM),T(8)
      DIMENSION NN(LIMP,8),IV3(LIMP),NA(100),NB(100),ISIG(LIMP)
      DIMENSION INIT(NFAM),IXIT(NFAM)
      COMMON/COMP/NN,IV3,ISIG,NGR,NARG,INDI,INDIC,NA,NB
      COMMON /COMP1/ALON,PG,APA,INIT,IXIT,INDMAX,INDMIN
      DATA RAD/.017453292519943D0/,DTUTD/57.D0/,Z/360.D+00/
c      DATA W/14.492052109D0,0.549016530D+0,0.041068639D+0,0.004641837D+0
c     10,0.002206413D+00,0.000001961D+00,.037604917D0,.025688387D0/
C     DIFFERENCE TDT-UTC IN SECONDS
C     CALL ETMUTC(6,0,TJUL,DTUTD)
      CALL TDTUTC(10,2,TJUL,DTUTD)
      call ddut1(Tjul,dut1,iter)
      he=he+dut1/3600.D0
C
      FS=(TJUL- 2451545.0D+00)/36525.D+00
      FD=FS+DTUTD/(86400.D0*36525.D0)
      FS2=FS*FS
      FS3=FS2*FS
      FD2=FD*FD
c      IF(NARG.EQ.6)GO TO 36
c     Tamura et CTE
            T(1) = 280.4606184D0 + 36000.7700536D0*FS
     *                              + 0.00038793D0*FS2
     *                              - 0.0000000258D0*FS3
            T(2) = 218.316656D0 + 481267.881342D0*FD - 0.001330D0 *FD2
            DT2=   0.0040D0*DCOS( ( 29.D0+133.D0*FD)*RAD )
            T(1) =  T(1) - T(2)
            T(2) =  T(2) + DT2
            T(3) = 280.466449D0  + 36000.769822D0*FD + 0.0003036D0*FD2
     *            + 0.0018D0*DCOS( (159.D0+ 19.D0*FD)*RAD )
            T(4) =  83.353243D0   + 4069.013711D0*FD - 0.010324D0 *FD2
            T(5) = 234.955444D0   + 1934.136185D0*FD - 0.002076D0 *FD2
            T(6) = 282.937348D0      + 1.719533D0*FD + 0.0004597D0*FD2
      if(narg.eq.8)then
            T(7) = 248.1D0       + 32964.47D0    *FD
            T(8) =  81.5D0       + 22518.44D0    *FD
                    end if
      DO 37 J=2,NARG
      JJ=dint(T(J)/Z)
	if(JJ.ne.0)then
      U=dble(JJ)
      T(J)=T(J)-U*Z
c      if(t(j).gt.180.D0)t(j)=t(j)-Z
	           end if
   37 CONTINUE
 7511 T(1)=T(1)+(HE*15.D+00+ALON)
   30 JJ=dint(T(1)/Z)
      if(JJ.ne.0)then
      U=dble(JJ)
      T(1)=T(1)-U*Z
	           endif
      write(10,1000)(k,t(k),k=1,narg)
 1000 format(' T(',I1,') ',F20.12)
C
C     CALCUL DES ARGUMENTS DES ONDES DE MAREE
C
      DO 40 INDIC=INDMIN,INDMAX
      ARG=0.D0
      IF(INDI.EQ.3.or.indi.eq.8)ARG=ARG+90.D+00
      K1=INIT(INDIC)
      K2=IXIT(INDIC)
      N1=NA(K1)
      N2=NB(K2)
      DO 40 I=N1,N2
      R(I)=ARG
      DO 41 J=1,NARG
      CN=NN(I,J)
      R(I)=R(I)+T(J)*CN
   41 CONTINUE
      R(I)=R(I)+ISIG(I)*90.D0
      IVV=IV3(I)-1
      IF(IVV.LE.0)IVV=1
      R(I)=R(I)+PG(IVV,INDIC)
   31 JJ=dint(R(I)/Z)
      if(JJ.ne.0)then
      U=dble(JJ)
      R(I)=R(I)-U*Z
	           endif
   40 CONTINUE
      RETURN
      END
