      SUBROUTINE COGETW(TJULO,UN,RDS,NY,MAT3,ISTA,NON)
C     LIMP : DIMENSION MAXIMALE DU POTENTIEL
C     NFAM : NOMBRE DE FAMILLES D'ONDES
C     NPOT : NOMBRE D'ORDRES DU POTENTIEL (V2,V3,V4,..)
C     8 possible components
      PARAMETER (NFAM=5,ISEP=6)
      PARAMETER (NPOT=3)
      PARAMETER (LIMP=3200)
C
C     CALCUL DES COEFFICIENTS GEODESIQUES
C     LECTURE DES CARTES MAITRESSES
C
      DOUBLE PRECISION VITA(LIMP),PG(NPOT,NFAM),DPOISS
      DOUBLE PRECISION RHO,CN,ALON,ALAT,ATT,GE,AZ,UN,RDS,DHTU,PS,RAY
      DOUBLE PRECISION W(8),ZZ(NPOT,NFAM),XX(NPOT,NFAM),YY(NPOT,NFAM),
     *G(NPOT),PSI,ALON1,CPSI,SPSI,TJULO,FREQ(150),viti,vitm3,vitm4
      DIMENSION GD0(150),GD1(150),GD2(150),IPOT(150)   
      CHARACTER*12 compi(8)
      CHARACTER*8 OX(150),OD(100)
      CHARACTER*6 FIN,TI(13),ONDE
      character*1 dieze
      DIMENSION H(LIMP),APA(100),DELTA(100),VIT(100),facam(100)
      DIMENSION G0(NPOT,NFAM),G1(NPOT,NFAM),G2(NPOT,NFAM),facpha(100)
c      character*1 FNS(2),FEW(2)
      DIMENSION NA(100),NB(100),NN(LIMP,8),IV3(LIMP),ITNA(150)
      DIMENSION NPRINX(150),ITNB(150),NGT(NFAM),NPRINC(100)
      DIMENSION INIT(NFAM),IXIT(NFAM),ISIG(LIMP),ndegr(3)
      COMMON /POT/OX,H,VITA
      COMMON/POT1/NGT,ITNA,ITNB,NPRINX,NOT
      COMMON /COMP/NN,IV3,ISIG,NGR,NARG,INDI,INDIC,NA,NB,mat2
      COMMON /COMP1/ALON,PG,APA,INIT,IXIT,INDMAX,INDMIN
      COMMON /CONSIT/RHO,ALON1,ALAT,ATT,GE,AZ
      COMMON /DDW/FREQ,IPOT,GD0,GD1,GD2,NWDW,MOLWDW  
      DATA FIN/'99    '/,dieze/'#'/,nout/10/
      DATA W/14.492052120365D+0,0.5490165199D+0,0.041068640D+0,
     10.004641835D+0,0.00220640678D+00,0.000001961594D+00,
     2.037604916724D0,.02568838695D0/,ndegr/3*0/
      DATA compi/'VERTICAL','NORTH-SOUTH','EAST-WEST','VERT. DISPL.',
     *'STRAIN HOR','STRAIN V','HOR. DISPL.','HOR. DPL. EW'/
      data vitm3/43.47615814d0/,vitm4/ 57.96820831d0/
      RHO = 0.017453292519943D+00
      NCOUP=1
      NC=11
C
C     OPTIONS STANDARD
C
  228 IF(MAT2.EQ.9)THEN
      MAT10=9
      MAT1=1
      MAT3=7
                   ELSE
C     MAT10 : POTENTIEL(LECTAM)
C     MAT1  : =0 SORTIE ECRAN , =1 SORTIE FICHIER
C     MAT2  : =0 NORMAL , =1,2,.. CALCUL DES DEPLACEMENTS(MT81)
C     MAT3  : =0 NORMAL , =1,2,.. FACTEURS OBSERVES
C           : =6 PAS ATTENUATION ORDRE TROIS , =6,7 PAS CORR.INERT
      print 2260
2260  format(1h ,'base option for potential:MAT10 / 1(CTE) or 9(TAM)')
      read(*,*)MAT10
      write(*,*)mat10
c      if(MAT10.eq.99)go to 99
      print 2261
2261  format(1h ,'basic options MAT1 MAT2 MAT3')
      read(*,*)MAT1,MAT2,MAT3
                    END IF
      write(*,*)mat1,mat2,mat3
      NY=8
      IF(MAT1.EQ.0)NY=6
C
C     INITIALISATION
C
      DO 225 I=1,NPOT
      DO 225 J=1,NFAM
      XX(I,J)=0.D0
      YY(I,J)=0.D0
      ZZ(I,J)=0.D0
      G1(I,J)=0.D0
      G2(I,J)=0.D0
      PG(I,J)=0.D+00
      G0(I,J)=0.D+00
  225 CONTINUE
C
C     LECTURE DES COORDONNEES ASTRONOMIQUES
C
      READ(NC,110)INDI,ALON,ALAT,ATT,GE,AZ,UN,RDS,DHTU
  110 FORMAT(I2,7F10.0,F8.0)
      if(ge.eq.0.)ge=981.D0
      k=indi+1
      write(9,2213)compi(k),alat,alon
      write(12,2215)dieze,compi(k),alat,alon
      write(9,2214)att,ge,az,un,dhtu
      write(12,2216)dieze,att,ge,az,un,dhtu
 2213 format(' component ',A12,' latitude ',f8.3,' longitude ',f8.3)
 2214 format(' altitude(km) ',f5.3,' gravity ',f8.0,' azimuth ',f8.3/,
     *' scale factor ',f8.3,' time correction(hour) ',f8.3)
 2215 format(A1,' component ',A12,' latitude ',f8.3,' longitude ',f8.3)
 2216 format(A1,' altitude(km) ',f5.3,' gravity ',f8.0,' azimuth ',f8.3/
     *,'# scale factor ',f8.3,' time correction(hour) ',f8.3)
      PRINT 111,INDI,ALON,ALAT,ATT,GE,AZ,UN,RDS,DHTU
      write(nout,111)compi(k),alon,alat,att,ge,az,un,rds,dhtu
  111 FORMAT(A12,' LONG=',F10.5,' LAT=',F10.5,' H=',F6.3,' G=',F6.0/,
     *4F10.5)
c      IF(MAT4.EQ.1)GO TO 300
  201 FORMAT(13A6)
  213 FORMAT(1H ,13A6)
  214 FORMAT(A1,13A6)
  215 READ(NC,201)(TI(I),I=1,13)
      IF(TI(1).EQ.FIN)GO TO1216
      write(nout,213)(ti(i),i=1,13)
      WRITE( 6,213)(TI(I),I=1,13)
      WRITE(9,213)(TI(I),I=1,13)
      write(12,214)dieze,(ti(i),i=1,13)
      GO TO 215
 1216 READ(NC,160)ISTA
  160 FORMAT(I4,F6.0)
C
C     NOMBRE DE JOURS
C
  302 INDI=INDI+1
      ALON1=ALON
      IF(MAT2.EQ.9)THEN
      I6MOI=2000
c      TJULO=0.
                   ELSE
      write(*,9160)
 9160 format(' NUMBER OF DAYS FOR GROUP SEPARATION ')
      READ(*,*)I6MOI
c      write(*,9161)
c 9161 format(' INITIAL EPOCH: year,month,day ')
c      read(*,*)IAN,MO,JO
c      TJULO=TJUL(IAN,MO,JO)+2415020.d0
                   END IF
c      IF(TJULO.EQ.0)TJULO=2451545.0D0
      PRINT 3020,TJULO
      write(nout,3020)tjulo
      write(9,3020)tjulo
      write(12,3021)dieze,tjulo
 3020 FORMAT(1H ,'JULIAN DATE AT ORIGIN',F10.1)
 3021 FORMAT(A1,' JULIAN DATE AT ORIGIN',F10.1)
C
C     AZIMUT DES PENDULES
C
 1222 IF(AZ.EQ.0)GO TO 1225
      GO TO(1217,1227,1224,1217,1226,1217,1227,1224),INDI
c     tilt and displ.NS
 1227 WRITE( 6,2227)AZ
      write(nout,2227)az
      write(9,2227)az
      write(12,2226)dieze,az
 2226 FORMAT(A1,7H AZIMUT,F6.2,3HN-E)
 2227 FORMAT(7H AZIMUT,F6.2,3HN-E)
      GO TO 1225
c     tilt and displ.EW
 1224 INDI=INDI-1
      AZ=AZ+90.D0
      GO TO 1227
c     strain
 1226 WRITE(6,2229)AZ
      write(nout,2229)az
      write(9,2229)az
      write(12,2228)dieze,az
      AZ=-AZ
 2228 FORMAT(A1,' STRAIN IN AZIMUT',F6.2,3HN-E)
 2229 FORMAT('STRAIN IN AZIMUT',F6.2,3HN-E)
c
 1225 AZ=AZ*RHO
      C2AZ=DCOS(2.D0*AZ)
      S2AZ=DSIN(2.D0*AZ)
      CAZ=DCOS(AZ)
      SAZ=DSIN(AZ)
 1217 CONTINUE
      IF(RDS.NE.0.)then
      WRITE( 6,2000)RDS
      WRITE(nout,2000)RDS
      write(9,2000)RDS
      write(12,1999)dieze,RDS
      end if
      IF(DHTU.NE.0.)then
      WRITE( 6,2001)DHTU
      WRITE(nout,2001)DHTU
      write(9,2001)DHTU
      write(12,2002)dieze,DHTU
      end if
 1999 FORMAT(A1,1H ,'TIME SHIFT',F6.2,' HOUR')
 2000 FORMAT(1H ,'TIME SHIFT',F6.2,' HOUR')
 2001 FORMAT(1H ,'LOCAL TIME=UT PLUS',F6.1,6H HOURS)
 2002 FORMAT(A1,1H ,'LOCAL TIME=UT PLUS',F6.1,6H HOURS)
      RDS=RDS+DHTU
      WRITE( 6,202)
  202 FORMAT(1H )
C
C     RESOLUTION DES GROUPES
C
      INDMIN=1
      if(indi.eq.3.or.indi.eq.8)indmin=2
      IF(I6MOI.GE.2000)THEN
      if(mat10.eq.1)then
      indmax=4
                    else
      INDMAX=5
                    end if
      NTYP=4
      END IF
      IF(I6MOI.LT.2000)THEN
      INDMAX=4
      NTYP=3
      END IF
      IF(I6MOI.LT.365)THEN
      NTYP=2
      END IF
      IF(I6MOI.LT.180)THEN
      INDMIN=2
      INDMAX=3
      NTYP=1
      END IF
c      write(nout,*)ntyp,indmin,indmax
C
      CALL LECTAM(MAT10,NTYP,TJULO)
c      write(nout,2250)(ox(k),k=1,ngr)
c      write(nout,2251)(h(k),k=1,not)
 2250 format(10A8)
 2251 format(10f8.5)
C
C     CALCUL DES COEFFICIENTS GEODESIQUES
C
      ALAT=ALAT*RHO
      PS=DTAN(ALAT)*(297.25D+00/298.25D+00)**2
      PS=DATAN(PS)
      psdeg=ps/rho
      write(nout,112)psdeg
  112 format(' GEOCENTRIC LATITUDE ',F10.5)
      RAY=1.D+00-3.35289D-03*DSIN(ALAT)**2+ATT/6378.16
      SPS=DSIN(PS)
      CPS=DCOS(PS)
      S2PS=DSIN(2.D0*PS)
      C2PS=DCOS(2.D0*PS)
      SPS2=SPS*SPS
      CPS2=CPS*CPS
      ZZ(1,1)=1.-3.*SPS2
      ZZ(2,1)=3.35409*SPS*(3.-5.*SPS2)
      ZZ(1,2)=2.*S2PS
      ZZ(2,2)=2.1785*CPS*(1.-5.*SPS2)
      ZZ(1,3)=2.*CPS2
      ZZ(2,3)=7.79424*SPS*CPS2
      ZZ(2,4)=3.*CPS**3
      ZZ(3,1)=0.5*(3.-30.*SPS2+35.*SPS2*SPS2)
      ZZ(3,2)=1.893892*S2PS*(3.-7.*SPS2)
      ZZ(3,3)=(28./9.)*CPS2*(1.-7.*SPS2)
      ZZ(3,4)=6.1584*S2PS*CPS2
      ZZ(3,5)=4.*CPS2*CPS2
      XX(1,1)=-1.5*S2PS
      XX(2,1)=-3.35409*CPS*(5.*SPS2-1.)
      XX(1,2)=2.*C2PS
      XX(2,2)=-.72618*SPS*(15.*CPS2-4.)
      XX(1,3)=-S2PS
      XX(2,3)=2.59808*CPS*(1.-3.*SPS2)
      XX(2,4)=-3.*SPS*CPS2
      XX(3,1)=1.25*S2PS*(7.*SPS2-3.)
      XX(3,2)=0.946946*(3.*C2PS-7.*S2PS**2+7.*SPS2)
      XX(3,3)=-(7./9.)*S2PS*(14.*CPS2-6.)
      XX(3,4)=3.0792*CPS2*(1.-4.*SPS2)
      XX(3,5)=-2.*S2PS*CPS2
      YY(1,2)=-2.*SPS
      YY(2,2)=-.72618*(1.-5.*SPS2)
      YY(1,3)=-2.*CPS
      YY(2,3)=-2.59808*S2PS
      YY(2,4)=-3.*CPS2
      YY(3,2)=-.946946*SPS*(3.-7.*SPS2)
      YY(3,3)=-(14./9.)*CPS*(1.-7.*SPS2)
      YY(3,4)=-9.2376*SPS*CPS2
      YY(3,5)=-4.*CPS*CPS2
      PSI=ALAT-PS
      CPSI=DCOS(PSI)
      SPSI=DSIN(PSI)
c      IF(MAT2.NE.1)GO TO 6
c      PSI=0.D0
c      DO 60 K=1,NPOT
c      DO 60 J=1,NFAM
c      ZPOT=K+1
c      ZZ(K,J)=ZZ(K,J)/ZPOT
c   60 CONTINUE
c      ENTRY COGEO1(NY)
    6 GO TO(1,2,3,1,13,1131,2,3),INDI
    1 DO 621 K=1,NPOT
      G(K)=41.291125D0*(RAY**K)
      IF(indi.eq.4)then
       ZPOT=K+1
c      G(K)=-20.645625D03*(RAY**(K+1))/GE
      G(K)=268462.D0*(RAY**(K+1))/(ZPOT*GE)
      DO 619 J=1,NFAM
      G0(K,J)=G(K)*ZZ(K,J)
  619 continue
                    else
      DO 620 J=1,NFAM
      G0(K,J)=-G(K)*(ZZ(K,J)*CPSI+XX(K,J)*SPSI)
  620 CONTINUE
                    end if
  621 CONTINUE
      GO TO 4
    2 DO 622 K=1,NPOT
      G(K)=(8.516906D+03/GE)*(RAY**K)
c      IF(MAT2.EQ.2)G(K)=26.8462D0*981D0*(RAY**(K+1))/GE
      if(indi.eq.7)G(K)=268462.D0*(RAY**(K+1))/GE
      DO 622 J=1,NFAM
      G0(K,J)=G(K)*(XX(K,J)*CPSI-ZZ(K,J)*SPSI)
  622 CONTINUE
      IF(AZ.EQ.0)GO TO 4
      DO 132 K=1,NPOT
      DO 132 J=1,NFAM
      G1(K,J)=G0(K,J)*CAZ
  132 CONTINUE
    3 DO 623 K=1,NPOT
      G(K)=(8.516906D+03/GE)*(RAY**K)
c      IF(MAT2.EQ.2)G(K)=-26.8462D0*981D0*(RAY**(K+1))*CPS/GE
      if(indi.ge.7)G(K)=268462.D0*(RAY**(K+1))/GE
      DO 623 J=1,NFAM
      G0(K,J)=-G(K)*YY(K,J)
  623 CONTINUE
      IF(AZ.EQ.0)GO TO 4
      DO 133 K=1,NPOT
      DO 133 J=1,NFAM
      G2(K,J)=G0(K,J)*SAZ
  133 CONTINUE
  135 DO 134 K=1,NPOT
      DO 134 J=1,NFAM
c      write(nout,*)g1(k,j),g2(k,j)
      G0(K,J)=SQRT(G1(K,J)**2+G2(K,J)**2)
      IF(G1(K,J).EQ.0)GO TO 134
      PG(K,J)=ATAN2(G2(K,J),G1(K,J))/RHO
  134 CONTINUE
      GO TO 4
C     HORIZONTAL STRAIN
   13 G(1)=4.1291125D+04*RAY/GE
      CAZ2=CAZ*CAZ
C
C     MODELE MOLODENSKY I       V2        V3
C                          H   .6206     .289
C                          L   .0904     .0145
      V2L=0.1808D0
      VH2L=0.4398D0
      VMH=0.6206D0
      VML=0.0904D0
      VLH=VML/VMH
      VML3=0.0145D+00
      VMH3=0.289D0
      VLH3=VML3/VMH3
      V2LP=2.D+00*VML3
      V3LP=3.D+00*VML3
      VH3LP=VMH3-V3LP
      DO 613 K=2,NPOT
      G(K)=G(K-1)*RAY
  613 CONTINUE
      G1(1,2)=G(1)*(VH2L-V2L*CAZ2)*S2PS
      G2(1,2)=-G(1)*V2L*S2AZ*CPS
      G1(1,3)=G(1)*(VH2L*CPS2+V2L*(C2AZ-CPS2*CAZ2))
      G2(1,3)=G(1)*V2L*SPS*S2AZ
      G1(2,4)=G(2)*CPS*(VH3LP*CPS2+2.*V3LP*(C2AZ-CAZ2*CPS2))
      G2(2,4)=G(2)*CPS*V3LP*SPS*S2AZ
      G1(2,2)=0.72618*G(2)*CPS*(VH3LP*(1.-5.*SPS2)-V2LP*(C2AZ+3.*
     1(1.-5.*SPS2)*CAZ2))
      G2(2,2)=0.36309*G(2)*V2LP*5.*S2PS*S2AZ
      G1(2,3)=2.59808*G(2)*SPS*(VH3LP*CPS2+V2LP*(C2AZ-3.*CPS2*CAZ2))
      G2(2,3)=-2.59808*G(2)*V2LP*C2PS*S2AZ
      G1(1,1)=G(1)*(0.5*VMH*(1.-3.*SPS2)+3.*VML*(SPS2-CPS2*CAZ2))
      G2(1,1)=0.
      G1(2,1)=G(2)*1.11803*SPS*(VMH3*(3.-5.*SPS2)+V3LP*(5.*SPS2-1.
     1-10.*CPS2*CAZ2))
      G2(2,1)=0.
      DO 6007 J=1,npot
      K=J+1
      PRINT 6006,K
      WRITE(nout,6006)K
      PRINT 6003,(G1(J,L),L=1,5)
      WRITE(nout,6003)(G1(J,L),L=1,5)
      PRINT 6001,(G2(J,L),L=1,5)
      WRITE(nout,6001)(G2(J,L),L=1,5)
 6003 FORMAT(' G11 ',5F8.3)
 6001 FORMAT(' G22 ',5F8.3)
 6007 continue
      GO TO 135
C     VERTICAL STRAIN
 1131 DPOISS=0.25D0
      VMH=0.6206D0
      VML=0.0904D0
      VML3=0.0145D+00
      VMH3=0.289D0
      G(1)=4.1291125D+04*(dpoiss/(dpoiss-1.D0))*(6.D0*VML-2.D0*VMH)
     1*RAY/GE
      G(2)=4.1291125D+04*(dpoiss/(dpoiss-1.D0))*(6.D0*VML3-2.D0*VMH3)
     1*RAY**2/GE
      G0(1,2)=-G(1)*S2PS
      G0(2,2)=-G(2)*0.72618D+00*CPS*(1.D+00-5.D+00*SPS2)
      G0(1,3)=-G(1)*CPS2
      G0(2,3)=-G(2)*2.59808D+00*SPS*CPS2
      G0(2,4)=-G(2)*CPS**3
      G0(1,1)=G(1)*(3.D0*sps2-1.D0)/2.D0
      G0(2,1)=G(2)*1.11803*SPS*(5.*SPS2-3.)
C
    4 DO 6005 J=1,NPOT
      K=J+1
      PRINT 6006,K
      WRITE(nout,6006)K
 6006 FORMAT(1H ,'DEGREE ',I1)
      PRINT 6002,(G0(J,L),L=1,5)
      WRITE(nout,6002)(G0(J,L),L=1,5)
 6002 FORMAT(5F10.5)
      if(az.ne.0)then
      PRINT 6004,(PG(J,L),L=1,5)
      WRITE(nout,6004)(PG(J,L),L=1,5)
 6004 FORMAT(5F10.3)
      end if
 6005 CONTINUE
C
C     M0S0
C
      if(indi.eq.3.or.indi.eq.8)go to 40
      if(indi.eq.4.or.indi.eq.7)then 
       call MOLODW(FHM1,FHK1,FHL1,FACMS0,FASTH,.00220641D0,INDI,2,1)
       write(nout,*)facMS0
       H(1)=H(1)*facMS0
                   end IF
      if(dabs(pg(1,1)).gt.179.99D0)then
       H(1)=-G0(1,1)*H(1)
c       write(nout,*)H(1)
                        else
       H(1)=G0(1,1)*H(1)
                        end if
      AMTC=H(1)
c      IF(MAT2.EQ.1.OR.MAT2.EQ.2)GO TO 40
      WRITE(6,2140)INDI,AMTC
      write(nout,2140)indi,amtc
      WRITE(9,2140)INDI,AMTC
      WRITE(12,2141)dieze,INDI,AMTC
 2140 FORMAT(1H ,5X,'INDI=',I2,5X,'AMPLITUDE OF M0S0',F10.3)
 2141 FORMAT(A1,1H ,5X,'INDI=',I2,5X,'AMPLITUDE OF M0S0',F10.3)
C
C     REPARTITION DES GROUPES D ONDES
C
c   40 IF(MAT2.GE.2.AND.MAT2.LT.9)RETURN
   40 continue
      if(G0(1,1).eq.0)indmin=2
      NGF=0
      J=1
      NGR=0
      IF(indmin.EQ.2)then
      ngf=ngt(1)
      write(nout,*)indmin,indmax,ngt(1)
                    end if
   41 DO 14 K=INDMIN,INDMAX
      IF(NGT(K).EQ.0)GO TO 14
      NGO=NGF+1
      NGF=NGF+NGT(K)
      I0=NGR+1
      DO 15 I=NGO,NGF
c      write(nout,4200)i,ox(i),itna(i),itnb(i),nprinx(i)
      NA(J)=ITNA(I)
      NB(J)=ITNB(I)
      IF(NB(J).EQ.0)GO TO 15
      OD(J)=OX(I)
      NPRINC(J)=NPRINX(I)
      write(nout,4200)j,od(j),na(j),nb(j),nprinc(j)
      J=J+1
      NGR=NGR+1
   15 CONTINUE
      INIT(K)=I0
      IXIT(K)=NGR
      IF(MAT2.EQ.1)GO TO 14
      N1=NA(I0)
      N2=NB(NGR)
      DO 5 I=N1,N2
      IVV=IV3(I)-1
      ndegr(IVV)=ndegr(IVV)+1
      H(I)=  H(I)*G0(IVV,K)
    5 CONTINUE
      write(nout,4201)K,NGO,NGF,n1,n2
 4201 format(' FAMILLE ',I1,' groupes ',I2,'  ',I2,' , ondes ',I4,'  '
     *,I4)
 4200 format(' groupe',i3,5x,a6,3i5)
   14 CONTINUE
      NON=NB(NGR)
      IF(NON.GE.700)CALL VITTAM(TJULO,W,NARG)
      ndegr(1)=ndegr(1)+1
      write(nout,4202)NON,(k+1,ndegr(k),k=1,3)
 4202 format(' COMPUTATION WITH ',I4,' WAVES',' degrees', 3(I2,I5)/)
      DO 246 J=1,NGR
      N1=NA(J)
      N2=NB(J)
      DO 247 IJ=N1,N2
      VITA(IJ)=0.
      DO 248 K=1,NARG
      CN=NN(IJ,K)
      VITA(IJ)=VITA(IJ)+W(K)*CN
  248 CONTINUE
      IF(IJ.NE.NPRINC(J))GO TO 247
      VIT(J)=VITA(IJ)
      npt=iv3(ij)
      indic=nn(ij,1)+1
      viti=vita(ij)
      call MOLODW(FHM1,FHK1,FHL1,FACAM(j),facpha(j),VITI,INDI,NPT,INDIC)
      if(indi.eq.5)then
      write(nout,4203)j,od(j),vit(j),facam(j),facpha(j)
                   else
      write(nout,4203)j,od(j),vit(j),facam(j),facpha(j)
                   end if
 4203 format(I3,A6,F12.8,F10.5,F10.3)
  247 continue
c      write(nout,*)j,vit(j)
  246 CONTINUE
  636 CONTINUE
c      IF(MAT2.EQ.1)RETURN
C
C     AMPLITUDES OBSERVEES
C
      IF(MAT3.EQ.0)GO TO 150
      call MOLODW(FHM1,FHK1,FHL1,FACM3,FASM3,VITM3,INDI,3,4)
      call MOLODW(FHM1,FHK1,FHL1,FACM4,FASM4,VITM4,INDI,4,5)
      write(10,6341)FACM3,facm4
 6341 format(1h ,'facm3=',F12.8,' facm4=',f12.8)
      write(10,6342)FASM3,fasm4
 6342 format(1h ,'fasm3=',F12.5,' fasm4=',f12.5)
      READ(NC,192,end=152)N1
c     titles
      backspace nc
      PRINT 6345
      write(nout,6345)
      write(9,6345)
      write(12,6348)
 6345 FORMAT(10X,'OBSERVED AMPLITUDE AND PHASE OF THE GROUPS')
 6348 FORMAT('#',10X,'OBSERVED AMPLITUDE AND PHASE OF THE GROUPS')
      IF(INDI.EQ.1)then
      PRINT 6346
      write(nout,6346)
      write(9,6346)
      write(12,6349)
 6346 FORMAT(11H  GROUP    ,11H   NAME    ,10H AMPLITUDE,8H  PHASE ,
     *' INERTIAL CORR.')
 6349 FORMAT('#',11H  GROUP    ,11H    NAME   ,10H AMPLITUDE,8H  PHASE ,
     *' INERTIAL CORR.')
                   else
      PRINT 6347
      write(nout,6347)
      write(9,6347)
      write(12,6350)
 6347 FORMAT(11H  GROUP    ,'   NAME    ',' AMPLITUDE',8X,'PHASE')
 6350 FORMAT('#',11H  GROUP    ,'   NAME    ',' AMPLITUDE',8X,'PHASE')
                   end if
      ITEST=0
      DELT1=0
      hh1=0.
c     lecture des facteurs
      DO 955 I=1,NGR
      IF(ITEST.EQ.9999)GO TO 956
      READ(NC,192)N1,N2,ONDE,DELTA(I),APA(I)
  192 FORMAT(I4,1X,I4,2X,A6,15X,F8.5,8X,F9.4)
c      write(*,*)i,ngr
      ideb=i
      IF(N1-NA(I))999,956,999
c     calculs pour le groupe
  957 hh1=0.
      IF(INDI.GT.1.OR.MAT3.GE.6)then
c     no inertial correction
      delta1=delta(i1)
      PRINT 1591,N1,N2,ONDE ,DELTA(I1),APA(I1)
      write(nout,1591)n1,n2,onde,delta(i1),apa(i1)
      write(9,1591)N1,N2,ONDE ,DELTA(I1),APA(I1)
      write(12,1592)dieze,N1,N2,ONDE ,DELTA(I1),APA(I1)
 1592 FORMAT(A1,I6,1H-,I4,5X,A6,2(F10.6,F9.4))  
 1591 FORMAT(I6,1H-,I4,5X,A6,2(F10.6,F9.4))        
                                else
C     INERTIAL CORRECTION
      DELT1=0.0041*(VIT(I1)/30.)**2
      DELTA1=DELTA(I1)+DELT1
      PRINT 1591,N1,N2,ONDE ,DELTA(I1),APA(I1),DELT1      
      write(nout,1591)n1,n2,onde,delta(i1),apa(i1),delt1
      write(9,1591)N1,N2,ONDE ,DELTA(I1),APA(I1),DELT1
      write(12,1592)dieze,N1,N2,ONDE ,DELTA(I1),APA(I1),DELT1
                                end if
c     calcul des amplitudes des ondes
      continue
      INDIC=NN(IJ1,1)+1
      NWAVE=N2-N1+1
      NTDP=0
c      CALL MOLOD1(FHM1,FHK1,FHL1,FACAM,FASTH,VITA(IJ1),INDI,INDIC)
      facmain=facam(i1)
      phamain=facpha(i1)
c      if(indi.eq.4.or.indi.gt.6)then
      facres3=facm3/facmain
      facres4=facm4/facmain
c                                else
c      facres3=facm3/delta1
c      facres4=facm4/DELTA1
c                                end if
      if(ifin.gt.ideb.and.indic.eq.2)THEN
      do 958 k=ideb,ifin
      kj=nprinc(k)
      facrap=facam(k)/facmain
      if(INDI.eq.5)THEN
c       INDIC=NN(KJ,1)+1
       IVV=IV3(KJ)-1
c       IF(IVV.LT.2)IVV=1
	  apa(k)=apa(k)+(facpha(k)-phamain)
c       write(nout,*)ivv,indic,facam(k),facmain,apa(k),facpha(k),phamain
                   END IF
      do 959 kk=na(k),nb(k)
      if(iv3(kk).lt.3)h(kk)=h(kk)*facrap
  959 continue
      PRINT 1594,K,OD(K),vita(kj),facam(k),facrap
      write(nout,1594)K,OD(K),vita(kj),facam(k),facrap
      write(9,1594)K,OD(K),vita(kj),facam(k),facrap
      write(12,1595)dieze,K,OD(K),vita(kj),facam(k),facrap 
 1594 FORMAT(1H ,'GROUP ',I3,1X,A6,F12.8,' THEOR. FACTOR=',F8.4,
     *' RATIO=',F8.5)
 1595 FORMAT(A1,1H ,'GROUP ',I3,1X,A6,F12.8,' THEOR. FACTOR=',F8.4,
     *' RATIO=',F8.5)
           write(nout,1596)k,OD(k),vita(kj),facpha(k),apa(k)
  	   write(9,1596)k,OD(k),vita(kj),facpha(k),apa(k)
           write(12,1597)dieze,k,OD(k),vita(kj),facpha(k),apa(k)                 
  958 continue
                                    END IF
      if(indi.eq.4.or.indi.gt.6)then
c     displacement
       delta2=delta1*facmain
                                else
       delta2=delta1
                                end if
      DO 953 J=N1,N2
      if(indi.eq.5.or.indi.eq.6)go to 637
      IF(IV3(j).LT.3.OR.MAT3.EQ.6)GO TO 637
      IF(IV3(j).EQ.3)H(J)=H(j)*FACres3
      IF(IV3(J).EQ.4)H(J)=H(j)*FACres4
      NTDP=NTDP+1
  637 H(J)=H(J)*DELTA2
  953 CONTINUE
      IF(MAT3.NE.6)then
      PRINT 1590,I1,NWAVE,NTDP,H(IJ1),DELTA2
      write(nout,1590)i1,nwave,ntdp,h(ij1),delta2      
      write(9,1590)i1,nwave,ntdp,h(ij1),delta2
      write(12,1593)dieze,i1,nwave,ntdp,h(ij1),delta2 
 1590 FORMAT(1H ,'GROUP ',I3,2I5,' AMPL.=',F8.4,' DELTA=',F10.6)
 1593 FORMAT(A1,1H ,'GROUP ',I3,2I5,' AMPL.=',F8.4,' DELTA=',F10.6)
                   end if
      go to 955
c     iteration
  956 ITEST=0
      ifin=i
      IJ=NPRINC(I)
      if(abs(h(ij)).gt.hh1)then
      hh1=abs(h(ij))
      i1=i
      ij1=ij
                           end if
c     fin de groupe
c      write(*,*)n2,nb(i)
      IF(N2-NB(I))999,957,954
  954 IF(I.EQ.NGR)GO TO 999
      DELTA(I+1)=DELTA(I)
      APA(I+1)=APA(I)
      ITEST=9999
c
  955 CONTINUE
      MAT3=1
      return
c
c     No tidal parameters (rigid Earth)
c
  150 if(indi.gt.3)go to 98
      DO 151 J=1,NGR
      IJ=NPRINC(J)
      PRINT 5010,J,NA(J),NB(J),NPRINC(J),OD(J),VIT(J),H(IJ)
      write(nout,5010)j,na(j),nb(j),nprinc(j),od(j),vit(j),h(ij)
      write(9,5010)J,NA(J),NB(J),NPRINC(J),OD(J),VIT(J),H(IJ)
      write(12,5011)dieze,J,NA(J),NB(J),NPRINC(J),OD(J),VIT(J),H(IJ)
 5010 FORMAT(1H ,'GROUP  ',I2,5X,3I4,2X,A6,F10.6,2F10.5)
 5011 FORMAT(A1,1H ,'GROUP  ',I2,5X,3I4,2X,A6,F10.6,2F10.5)      
  151 CONTINUE
      mat3=0
      RETURN
c
c     theoretical model
c
  152 do 154 I=1,NGR
      ndtp=0
      IJ=NPRINC(I)
      facmain=facam(i)
      PRINT 5010,I,NA(i),NB(i),NPRINC(i),OD(i),VIT(i),H(IJ),facmain
      write(nout,5010)i,na(i),nb(i),nprinc(i),od(i),vit(i),H(IJ),facmain
      write(9,5010)I,NA(i),NB(i),NPRINC(i),OD(i),VIT(i),H(IJ),facmain
      write(12,5011)dieze,I,NA(i),NB(i),NPRINC(i),OD(i),VIT(i),H(IJ),
     *facmain
c     strain
      if(INDI.eq.5.or.indi.eq.6)THEN
       INDIC=NN(IJ,1)+1
       IVV=IV3(IJ)-1
c       IF(IVV.LT.2)IVV=1
c       write(nout,*)ivv,indic,g0(ivv,indic),pg(ivv,indic)
       if(g0(ivv,indic).ne.0.)facmain=facmain/G0(ivv,indic)
        if(indic.eq.2)then
         write(nout,1594)I,OD(I),vit(I),g0(ivv,indic),facmain
         write(9,1594)I,OD(I),vit(I),g0(ivv,indic),facmain
         write(12,1595)dieze,I,OD(I),vit(I),g0(ivv,indic),facmain
                      end if
         if(indi.eq.5)then
	  apa(i)=facpha(i)-pg(ivv,indic)
          if(indic.eq.2)then 
           write(nout,1596)I,OD(I),vit(I),facpha(I),apa(I)
  	   write(9,1596)I,OD(I),vit(I),facpha(I),apa(i)
           write(12,1597)dieze,I,OD(I),vit(I),facpha(I),apa(I)                 
 1596 FORMAT(1H ,'GROUP ',I3,1X,A6,F12.8,' THEOR. PHASE=',F8.4,
     *' PHASE DIFF.=',F8.3)
 1597 FORMAT(A1,1H ,'GROUP ',I3,1X,A6,F12.8,' THEOR. PHASE=',F8.4,
     *' PHASE DIFF.=',F8.3)
                        end if
                     end if
                                END IF
      do 153 j=na(i),nb(i)
      if(INDI.eq.5.or.indi.eq.6)go to 156      
      IF(IV3(j).EQ.3)H(J)=H(j)*FACM3
      IF(IV3(J).EQ.4)H(J)=H(j)*FACM4
      NTDP=NTDP+1
  156 if(iv3(j).lt.3)h(j)=h(j)*facmain
  153 continue
  154 continue
      return
c
c     erreurs
   98 print 1198,compi(indi)
 1198 format(' no ',A12,'for a rigid earth')
      go to 99
  999 PRINT 193,I
  193 FORMAT(28H INCORRECT TIDAL GROUP    N=,I3)
   99 write(9,'(A$)')'88888888'
      STOP
      END
