C
C     CALCUL DE LA MAREE THEORIQUE
C     DEVELOPPEMENT DU POTENTIEL SUIVANT CARTWRIGHT,TAMURA,XI-QIN-WEN
C
C     LIMP : DIMENSION MAXIMALE DU POTENTIEL
C     NFAM : NOMBRE DE FAMILLES D'ONDES
C     ISEP : SEPARATION DES GROUPES , MAXIMUM 35 GROUPES AU TOTAL
C     NPOT : NOMBRE D'ORDRES DU POTENTIEL (V2,V3,V4,..)
      PARAMETER (NFAM=5,ISEP=6)
      PARAMETER (NPOT=3)
      PARAMETER (LIMP=3200)
      DOUBLE PRECISION R(LIMP),PG(NPOT,NFAM)
      DOUBLE PRECISION RHO,ALON,UN,RDS,TJUU,TJULO,HE,PAS,FN,pow
      DOUBLE PRECISION TJUL1,HE1,FKOS,FCIN
      DOUBLE PRECISION VIT(LIMP),KOT(LIMP),CIT(LIMP),KOSN(LIMP),
     *CINN(LIMP),FREQ(150)
      DIMENSION GD0(150),GD1(150),GD2(150),IPOT(150)  
      DIMENSION H(LIMP),APA(100),IDO(60),INIT(NFAM),IXIT(NFAM),fdo(60)
      DIMENSION NN(LIMP,8),IV3(LIMP),NA(100),NB(100),ISIG(LIMP)
      CHARACTER*80 FILIN
      CHARACTER*8 OD(150),titmod(4)
      character*4 form(5),formh(6),formm(6)
      CHARACTER*1 atit(79),yes,yesno
      COMMON/POT/OD,H,VIT
      COMMON/COMP/NN,IV3,ISIG,NGR,NARG,INDI,INDIC,NA,NB,MAT2
      COMMON /COMP1/ALON,PG,APA,INIT,IXIT,INDMAX,INDMIN
      COMMON /DDW/FREQ,IPOT,GD0,GD1,GD2,NWDW,MOLWDW  
      DATA atit/79*'*'/,YES/'Y'/,dieze/'#'/,nblo/0/,APA/100*0./
      DATA nbias/0/,dsapr/1./,isec/0/,offset/0./,dcal/1./,dtlag/0./
      DATA IRECO/0/,id7/77777777/,id9/99999999/,id8/88888888/,mat2/9/
      data form/'i5)','i6)','i7)','i8)','i9)'/,molwdw/6/
      data formh/'(2i4',',i5',',3i2',',i1',',12','i5)'/
      data formm/'(2i4',',i4',',3i2',',i2',',12','i6)'/
C
C     OUVERTURE DES FICHIERS
C
      open(unit=8,file='mt80tw.out',status='UNKNOWN')      
      open(unit=9,file='mt80te.out',status='UNKNOWN')
      open(unit=12,file='mt80tm.out',status='UNKNOWN')
      open(unit=10,file='mt80tw.lst',status='unknown')
      open(unit=30,file='etpolut1.dat',status='old')
      WRITE(*,'(A$)')' FILENAME FOR STATION SSSSMTHT.dat or SSSSMTHB.dat
     * '
      READ(*,'(A)')FILIN
      write(6,5010)filin
      write(9,5010)filin
      write(10,5010)filin
      write(12,5008)filin
 5008 format('# input file: ',A15)
 5010 format(' input file: ',A15)
      open(unit=11,file=FILIN,status='old')
      open(unit=14,file='grouplim.dat',status='old')
      open(unit=15,file='tdtutc.dat',status='old')
c
      RHO = 0.017453292519943D+00
      NDJ=30

      WRITE(*,'(A$)')' STANDARD OPTIONS:Yes or No '
      READ(*,'(A)')yesno
      if(yesno.ne.yes)THEN
       mat2=0
       WRITE(*,'(A$)')' FILENAME FOR POTENTIAL '
       READ(*,'(A)')FILIN
       write(6,*)filin
       write(9,*)filin
       write(10,*)filin
       write(12,*)dieze,filin
       open(unit=13,file=FILIN,status='old')      
c     model selection
      WRITE(*,'(A$)')' tidal model: 1=DPREMZ, 2=HYDRO, 3=NON_HYDRO'
      read(*,*)modsel
      goto(111,112,113)modsel
  111 open(unit=16,file='dpremz.dat',status='old')
      go to 110
  112 open(unit=16,file='hydro.dat',status='old')
      go to 110
  113 open(unit=16,file='nonhydro.dat',status='old')
  110 continue
                      ELSE
       open(unit=13,file='tam1200.dat',status='old')      
       write(*,'(A$)')' Tidal Potential: TAMURA '
       write(9,'(A$)')' TIDAL POTENTIAL: TAMURA '
       write(10,'(A$)')' TIDAL POTENTIAL: TAMURA '
       write(12,'(A$)')'# TIDAL POTENTIAL: TAMURA '
       open(unit=16,file='nonhydro.dat',status='old')
                      END IF 
c     Earth Tidal Model 
      IF(MOLWDW.GE.6)      THEN
C     LECTURE DU MODELE DDW
      read(16,1997)titmod
 1997 format(4A8)
      K=1
  997 READ(16,998)IEND,FREQ(K),OND,IPOT(K),GD0(K),GD1(K),GD2(K)
  998 FORMAT(I2,22X,F12.8,A4,I1,9X,3F7.5)
      IF(IEND.LT.99)THEN
c     WRITE(6,996)IEND,FREQ(K),OND,IPOT(K),GD0(K),GD1(K),GD2(K)
c 996 FORMAT(1H ,I2,F13.8,1x,A4,I2,3X,3F8.5)       
      K=K+1
      GO TO 997
                    ELSE
      NWDW=K-1
                    END IF   
      PRINT 1020,titmod
      write(9,1020)titmod
      write(10,1020)titmod
      write(12,1021)titmod
 1020 FORMAT(1H ,' MODELE WAHR-DEHANT: ',4A8/)
 1021 FORMAT(1H#,' MODELE WAHR-DEHANT: ',4A8)
c     modele MOLODENSKY
                           ELSE
      PRINT 1010
      write(9,1010)
      write(10,1010)
      write(12,1011)
 1010 FORMAT(1H ,' MODELE MOLODENSKII'/)
 1011 FORMAT(1H#,' MODELE MOLODENSKII'/)
                          END IF
C
C     LECTURE DES INTERVALLES DE TEMPS
C
    6 N=1
      print 6161
6161  format(1h ,'introduce computing step: '
     *' 0= hour, 1= 30minutes, 2= one minute, 99=END')
      read(*,*)IND1
c      IF(IND1.EQ.99)GO TO 228
      IF(IND1.EQ.99)GO TO 99
      print 6162
6162  format(1h ,'initial epoch:year,month,day,')
      read(*,*)IAN,MO,JO
      write(6,*)IAN,MO,JO
      IHE=0
      if(ian.lt.1000)ian=ian+1900
      TJULO=TJUL(IAN,MO,JO)+2415020.d0
C
  149 print 6163
6163  format(1h ,'final epoch:year,month,day')
      read(*,*)IAN1,MO1,JO1
      write(6,*)IAN1,MO1,JO1
      IHE1=0
      if(ian1.lt.1000)ian1=ian1+1900
      write(*,*)ireco
      if(ireco.eq.0)then
c
c     lecture des ondes
c
       CALL COGETW(TJULO,UN,RDS,NY,MAT3,ISTA,NON)
       NDB=NA(1)
       pow=dlog10(un)
       ipow=idnint(pow)+1
c       if(ipow.eq.0)go to 6
       formh(6)=form(ipow)
       formm(6)=form(ipow+1)
      write(9,2280)atit
 2280 format('C',79A1)
                    end if
c
c     debut bloc ETERNA
c
      nblo=nblo+1
      write(9,5007)filin,dcal,dsapr,dtlag,nbias
 5007 format(A15,2F10.4,F10.3,I10,' BLOCK') 
      write(9,5006)id7,offset
 5006 format(I8,7x,10f10.3) 
C
C     FIN DE CALCUL
C
  660 KDAFIN=IAN1*100000+MO1*1000+JO1*10+IHE1
      icent=(ian/100)*100
      write(6,6164)icent
 6164 format(' years counted from',i5)
      KDEB=IAN*100000+MO*1000+JO*10+IHE
      if(kdafin.lt.kdeb)then
      write(*,6166)IAN,MO,JO
 6166 format(' initial epoch',I5,2I3,' greater than final one')
      go to 149
                        end if
      PAS=1.D+00
      IF(IND1.EQ.1)PAS=0.5D+00
      IF(IND1.EQ.2)PAS=PAS/60.D0
C
C     VITESSES ANGULAIRES
C
      DO 45 I=NDB,NON
      KOT(I)=DCOS(VIT(I)*RHO*PAS)
      CIT(I)=DSIN(VIT(I)*RHO*PAS)
   45 CONTINUE
C
C     EPOQUE INITIALE
C
      INDC=(INDI-1)*1000+999
      IF(IND1.EQ.2)PAS=1.D0
      KP=PAS*2.D+00
      HE=IHE*6
      HE=HE+RDS
      TJULO=TJUL(IAN,MO,JO)+2415020.d0+HE/24.d0
C
C     OPTIMALISATION DU NOMBRE DE JOURS POUR LA RECURRENCE
C
      HE1=IHE1*6
      HE1=HE1+RDS
      TJUL1=TJUL(IAN1,MO1,JO1)+2415020.d0+HE1/24.d0
      ITJUL1=idint(TJUL1-TJULO)
      IF(ITJUL1.LE.NDJ)THEN
      NDR=NDJ
                       ELSE
      DNJ=dble(NDJ)
      DJUL1=float(ITJUL1)
      DJULE=DJUL1/DNJ
      JUL1=ifix(DJULE)
      DJULE=float(JUL1+1)
      NDR=ifix(1.+DJUL1/DJULE)
                       END IF
      IF(IND1.EQ.2)NDR=NDR/60
      if(ndr.eq.0)ndr=1
      write(10,6000)KDEB,TJULO,KDAFIN,TJUL1,NDR
      PRINT 6000,KDEB,TJULO,KDAFIN,TJUL1,NDR
 6000 FORMAT(1H ,'START',I10,' TJULO=',F10.1,
     *'   END',I10,' TJUL1=',F10.1,' RECURRENCE',I5,' JOURS'/)
      NDR=NDR*2
      IF(IND1.EQ.1)NDR=NDR*2
      TJUU=TJULO
      iter=0
C
C     INITIALISATIONS
C
    7 IJUL=idint(TJUU)
      HE=IHE*6
      IHZ=HE
      HE=HE+RDS
      iter=iter+1
      PRINT 6001,TJUU
 6001 FORMAT(1H ,'BEGIN RECURRENCE',F12.1/)
      write(10,6001)tjuu
C
C     CALCUL DES ELEMENTS ASTRONOMIQUES
C
      CALL ELASTM(TJUU,R,HE,iter)
C
C     DEPHASAGE OBSERVE
C
      IF(MAT3.EQ.0)GO TO 72
      DO 73 I=1,NGR
      N1=NA(I)
      N2=NB(I)
      DO 73 J=N1,N2
      R(J)=R(J)+APA(I)
   73 CONTINUE
c      write(10,*)(apa(k),k=1,ngr)
C
C     CALCUL DES ONDES
C
C
C     PREMIER PAS
C
   72 DO 40 I=NDB,NON
      KOSN(I)=DCOS(R(I)*RHO)
      CINN(I)=DSIN(R(I)*RHO)
   40 CONTINUE
C
C     RECURRENCE
C
      NO=0
   44 NO=NO+1
      IF(NO.EQ.1)GO TO 30
      IJUL=idint(TJUU)
      HE=IHE*6
      IHZ=HE
      HE=HE+RDS
   30 IF(IND1.EQ.2)GO TO 31
c
c     format horaire
c
      DO 41 K=1,12
      FDON=0.
      DO 42 I=NDB,NON
      FDON=FDON+H(I)*KOSN(I)
      FKOS=KOSN(I)*KOT(I)-CINN(I)*CIT(I)
      FCIN=CINN(I)*KOT(I)+KOSN(I)*CIT(I)
      KOSN(I)=FKOS
      CINN(I)=FCIN
   42 CONTINUE
      IF(INDMIN.EQ.1)FDON=FDON+H(1)
      fdo(k)=fdon 
      FDON=FDON*UN
      if(INDI.EQ.1)fdo(k)=fdo(k)*10. 
c      FDON=FDON*10.
c      IF(FDON.LT.0)GO TO 74
c      IDO(K)=FDON+0.5
c      GO TO 41
c   74 IDO(K)=FDON-0.5
      IDO(K)=ANINT(FDON)
c      write(10,*)fdon
   41 CONTINUE
c     sortie
      imin=0
      ijul=ijul-2400000
      icent=ian/100
      IAZ=IAN-icent*100
      write(10,*)iaz,mo,jo,ihe,ido(1)
      WRITE(NY,formh)INDC,ISTA,IJUL,IAZ,MO,JO,IHE,(IDO(K),K=1,12)
      if(ian.lt.1900)then
      IAZ=IAN+1900
                    else
      IAZ=IAN
                    end if
      idat=iaz*10000+mo*100+jo
      do 410 k=1,12
      if(ind1.eq.1)then
c     bihoraire
      imin=(k-1)*30
      ihk=imin/60
      imin=imin-ihk*60
      khe=ihz+ihk
                   else
c     horaire
      khe=ihz+k-1
                   end if
      itim= khe*10000+imin*100+isec
      write(9,1003)idat,itim,fdo(k)      
 1003 format(i8,1x,i6,10f10.3)
      write(12,162)iaz,mo,jo,khe,imin,isec,fdo(k)
  162 format(I4,5I3,F10.3)
      ireco=ireco+1
  410 continue
      GO TO 32
C
C     FORMAT MINUTES
C
   31 DO 33 KK=1,12
      DO 36 K=1,60
      FDON=0.
      DO 34 I=NDB,NON
      FDON=FDON+H(I)*KOSN(I)
      FKOS=KOSN(I)*KOT(I)-CINN(I)*CIT(I)
      FCIN=CINN(I)*KOT(I)+KOSN(I)*CIT(I)
      KOSN(I)=FKOS
      CINN(I)=FCIN
   34 CONTINUE
      IF(INDMIN.EQ.1)FDON=FDON+H(1)
      FDON=FDON*UN
      fdo(k)=fdon
      if(INDI.EQ.1)fdo(k)=fdo(k)*10. 
      FDON=FDON*10.
c      IF(FDON.LT.0)GO TO 35
c      IDO(K)=FDON+0.5
c      GO TO 36
c   35 IDO(K)=FDON-0.5
      IDO(K)=ANINT(FDON)
   36 CONTINUE
c     sortie
      if(ian.lt.1900)then
      IAZ=IAN+1900
                    else
      IAZ=IAN
                    end if
      idat=iaz*10000+mo*100+jo
      DO 37 J=1,5
      IMIN=(J-1)*12
      I1=IMIN+1
      I2=IMIN+12
      WRITE(NY,formm)INDC,ISTA,IAZ,MO,JO,IHZ,IMIN,(IDO(I),I=I1,I2)
   37 CONTINUE
      do 411 k=1,60
      imin=k-1
      itim= ihz*10000+imin*100+isec
      write(9,1003)idat,itim,fdo(k)      
      write(12,162)iaz,mo,jo,ihz,imin,isec,fdo(k)
      ireco=ireco+1
  411 continue
      IHZ=IHZ+1
   33 CONTINUE
C
C     ITERATION
C
   32 FN=N
      TJUU=TJULO+PAS*FN/2.D+00
      N=N+1
C
C     TEST DE SEQUENCE
C
      call calend(ian,mo,jo,ihe,kp)
  210 KDAT=IAN*100000+MO*1000+JO*10+IHE
      IF(KDAT.EQ.KDAFIN)GO TO 60
      IF(NO.LT.NDR)GO TO 44
      GO TO 7
   60 WRITE(NY,165)
  165 FORMAT(4H9999)
      if(indi.lt.2)icent=icent*100
      write(6,6167)icent
 6167 format(' final year counted from',i6)
      write(9,5006)id9
      write(12,5009)dieze,nblo 
 5009 format(A1,'END OF BLOCK',I3)
      GO TO 6
   99 write(6,6165)ireco
 6165 format(' nombre de records',I6)
      write(9,5006)id8
      STOP
      END
