C     CALCUL DES VITESSES ANGULAIRES DES HUIT ARGUMENTS
C     DE TAMURA POUR UNE EPOQUE DONNEE
C     INPUT  : TJUL EPOQUE EN TEMPS JULIEN REDUIT
C     OUTPUT : DTM  VITESSES ANGULAIRES EN DEGRES PAR HEURE
      SUBROUTINE VITTAM(TJUL,W,NARG)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION W(8)
      DATA DTUTD/57.D0/,cenhe/876600.D0/
C     DIFFERENCE TDT-UTC IN SECONDS
      CALL TDTUTC(10,2,TJUL,DTUTD)
      FS=(TJUL- 2451545.0D+00)/36525.D+00
      FD=FS+DTUTD/(86400.D0*36525.D0)
      FS2=FS*FS
c     Tamura
      W(1)=(36000.7700536D0+2.D0*0.00038793D0*FS
     *      -3.D0*0.0000000258D0*FS2)/cenhe
      W(2)=(481267.881342D0 - 2.D0*0.001330D0 *FD)/cenhe
      W(1)=W(1)-W(2)
      W(3)=(36000.769822D0 + 2.D0*0.0003036D0*FD)/cenhe
      W(4)=(4069.013711D0 - 2.D0*0.010324D0 *FD)/cenhe
      W(5)=(1934.136185D0 - 2.D0*0.002076D0 *FD)/cenhe
      W(6)=(1.719533D0 + 2.D0*0.0004597D0*FD)/cenhe
      if(narg.eq.8)then
      W(7)=32964.47D0/cenhe
      W(8)=22518.44D0/cenhe
                    end if
      W(1)=W(1)+15.D0
      write(10,1001)(k,w(k),k=1,narg)
 1001 format(' VIT(',I1,')= ',F20.12)
      RETURN
      END
